 Imports System.Runtime.InteropServices

Public Class Form1

    <DllImport("WoosimPrinter.dll")> _
    Shared Function InitPrinter(ByVal sPortName As String, ByVal BaudRate As Integer, ByVal Protocol As Boolean) As Integer
    End Function
    <DllImport("WoosimPrinter.dll")> _
    Shared Function ControlCommand(ByVal Cmd() As Byte, ByVal Length As Integer) As Integer
    End Function
    <DllImport("WoosimPrinter.dll")> _
    Shared Function SaveSpool(ByVal strData As String, ByVal FontValue As Integer, ByVal Emphasis As Boolean) As Integer
    End Function
    <DllImport("WoosimPrinter.dll")> _
    Shared Function PrintSpool(ByVal Delete_Spool As Boolean) As Integer
    End Function
    <DllImport("WoosimPrinter.dll")> _
    Shared Sub CardRead(ByVal Track2 As Boolean)
    End Sub
    <DllImport("WoosimPrinter.dll")> _
    Shared Sub CardCancel()
    End Sub
    <DllImport("WoosimPrinter.dll")> _
    Shared Function ClosePrinter() As Boolean
    End Function
    <DllImport("WoosimPrinter.dll")> _
  Shared Function BmpSaveSpool(ByVal sBmpFilePath As String, ByVal iXPosition As Integer, ByVal iYPosition As Integer) As Integer
    End Function
    <DllImport("WoosimPrinter.DLL")> _
      Shared Function InitWlanPrinter(ByVal sIP_ADDR As String, ByVal iPortNum As Integer, ByVal nTimeout As Integer, ByVal bProtocol As Integer) As Integer
    End Function
    <DllImport("WoosimPrinter.DLL")> _
    Public Shared Function BarcodeSaveSpool(ByVal ucBarcodeType As Integer, ByVal ucBarWidth As Integer, ByVal ucBarHeight As Integer, ByVal HRI_On As Boolean, ByVal BarcodeData As String, ByVal iPrtWidth As Integer, _
    ByVal iPrtHeight As Integer, ByVal iXPos As Integer) As Integer
    End Function
    <DllImport("user32.dll")> _
   Private Shared Function RegisterWindowMessage( _
        ByVal lpString As String) As UInteger
    End Function

    Private WM_RECEIVE_MSG As Integer = RegisterWindowMessage("WOOSIM_PRT_OK")

    '***************************************************************************
    '           CONST DEFINE
    '***************************************************************************
    Private Const ACK As Integer = &H6
    Private Const NACK As Integer = &H15
    Private Const ENQ As Integer = &H5
    Private Const DATA As Integer = &H44
    Private Const STATUS_REQUEST As Integer = &H51
    Private Const STATUS_ANSWER As Integer = &H53
    Private Const EOT As Integer = &H4
    Private Const ETX As Integer = &H3
    Private Const CAN As Integer = &H18
    Private Const MSR_FAIL As Integer = &H4D

    ' Return Message 
    Private Const SUCCESS As Integer = 1
    Private Const SOCKET_ERROR As Integer = -1
    Private Const CONNECT_FAIL As Integer = -2
    Private Const ALREADY_CONNECTED As Integer = -3

    Private Const NOT_OPEN_THE_PORT As Integer = -11
    Private Const BUFFER_OVERFLOW As Integer = -12
    Private Const OPERATOR_ERROR As Integer = -13

    'barcode type
    Public Const UPCA As Int32 = 65
    Public Const UPCE As Int32 = 66
    Public Const EAN13 As Int32 = 67
    Public Const EAN8 As Int32 = 68
    Public Const CODE39 As Int32 = 69
    Public Const ITF As Int32 = 70
    Public Const CODABAR As Int32 = 71
    Public Const CODE93 As Int32 = 72
    Public Const CODE128 As Int32 = 73

    'print width
    Private Const _2INCH As Integer = 384
    Private Const _3INCH As Integer = 576
    Private Const _4INCH As Integer = 832

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim l1 As Integer

        For l1 = 1 To 10
            m_cboCtrlSetPort.Items.Add("COM" & l1)
        Next

        m_cboCtrlBaud.Items.Add("9600 BPS")
        m_cboCtrlBaud.Items.Add("19200 BPS")
        m_cboCtrlBaud.Items.Add("38400 BPS")
        m_cboCtrlBaud.Items.Add("57600 BPS")
        m_cboCtrlBaud.Items.Add("115200 BPS")

        m_cboCtrlProtocol.Items.Add("USE")
        m_cboCtrlProtocol.Items.Add("NOT USE")
    End Sub
    Private Sub OPEN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OPEN.Click

        Dim lbool As Boolean
        lbool = ClosePrinter()
        Dim m_strStatus As String = ""
        Dim SetPort As String = ""
        Dim BaudRate As Integer
        Dim SetProtcol As Boolean
        Dim sIP_ADDR As String = Me.textIPaddress.Text


        If chkTcpip.Checked Then


            Dim intReturnValue As Integer

            intReturnValue = InitWlanPrinter(sIP_ADDR, 1470, 3000, SetProtcol)

            Select Case intReturnValue
                Case 1 : m_strStatus = "Success"
                Case -1 : m_strStatus = "Already opened"
                Case -2 : m_strStatus = "Unable to open the port"
                Case -3 : m_strStatus = "Unable to configure the serial port"
                Case -4 : m_strStatus = "Unable to set the timeout parameters"
                Case -5 : m_strStatus = "No response from printer"
            End Select

            TextBox1.Text = m_strStatus.ToString
        Else

            Select Case (m_cboCtrlSetPort.SelectedIndex)
                Case 0 : SetPort = "COM1:"
                Case 1 : SetPort = "COM2:"
                Case 2 : SetPort = "COM3:"
                Case 3 : SetPort = "COM4:"
                Case 4 : SetPort = "COM5:"
                Case 5 : SetPort = "COM6:"
                Case 6 : SetPort = "COM7:"
                Case 7 : SetPort = "COM8:"
                Case 8 : SetPort = "COM9:"
                Case 9 : SetPort = "COM10:"
            End Select

            Select Case (m_cboCtrlBaud.SelectedIndex)
                Case 0 : BaudRate = 9600
                Case 1 : BaudRate = 19200
                Case 2 : BaudRate = 38400
                Case 3 : BaudRate = 57600
                Case 4 : BaudRate = 115200
            End Select

            Select Case (m_cboCtrlProtocol.SelectedIndex)
                Case 0 : SetProtcol = True
                Case 1 : SetProtcol = False
            End Select

            Dim intReturnValue As Integer

            intReturnValue = InitPrinter(SetPort, BaudRate, SetProtcol)

            Select Case intReturnValue
                Case 1 : m_strStatus = "Success"
                Case -1 : m_strStatus = "Already opened"
                Case -2 : m_strStatus = "Unable to open the port"
                Case -3 : m_strStatus = "Unable to configure the serial port"
                Case -4 : m_strStatus = "Unable to set the timeout parameters"
                Case -5 : m_strStatus = "No response from printer"
            End Select

            TextBox1.Text = m_strStatus.ToString

        End If
    End Sub


    Private Sub CLOSE_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click

        Dim m_strStatus As String = ""
        If (ClosePrinter()) Then
            m_strStatus = "Close success"
        Else
            m_strStatus = "Close failure"
        End If
        TextBox1.Text = m_strStatus.ToString

    End Sub

    Private Sub SAMPLE_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SAMPLE.Click
        Dim lr As Integer
        Dim m_strMsg As String = ""
        Dim strTmp As String = ""
        Dim LineSpace(2) As Byte
        LineSpace(0) = &H1B
        LineSpace(1) = &H20
        LineSpace(2) = &H0

        ControlCommand(LineSpace, 3)
        lr = SaveSpool(Chr(&HA) + Chr(&HA) + Chr(&HA), 0, False)

        'Title
        lr = SaveSpool("   SALES SLIP" + Chr(&HA), 3, True)
        lr = SaveSpool("--------------------------------" + Chr(&HA), 0, False)
        'Company
        lr = SaveSpool("MERCHANT NAME      Woosim Coffee" + Chr(&HA), 0, True)
        'Reg Number
        lr = SaveSpool("MASTER                LEE IL BOK" + Chr(&HA), 0, False)
        '//Address
        lr = SaveSpool("ADDRESS" + Chr(&HA) + " #501, DaerungTechnotown3th 448," + Chr(&HA) + "  Gasan-dong, Geumchun-gu, Seoul" + Chr(&HA) + "  Korea" + Chr(&HA), 0, False)

        '//Tel
        lr = SaveSpool("HELP DESK       (+82-2)2107-3714" + Chr(&HA), 0, False)

        lr = SaveSpool("--------------------------------" + Chr(&HA), 0, False)

        lr = SaveSpool("         WOOSIM CARD" + Chr(&HA), 1, False)

        lr = SaveSpool("--------------------------------" + Chr(&HA), 0, False)
        '//Card number
        lr = SaveSpool("CARD NO.             123-456-789" + Chr(&HA), 0, False)
        lr = SaveSpool("EXPIRY                2012/12/10" + Chr(&HA), 0, False)
        lr = SaveSpool("--------------------------------" + Chr(&HA), 0, False)
        lr = SaveSpool("DATE                  2008/05/15" + Chr(&HA), 0, False)
        lr = SaveSpool("TRANS CLASS             [Credit]" + Chr(&HA), 0, False)
        lr = SaveSpool("TERMINAL ID.           123456789" + Chr(&HA), 0, False)
        lr = SaveSpool("APPROVAL NO.           987654321" + Chr(&HA), 0, False)
        lr = SaveSpool("AMOUNT                   500.00$" + Chr(&HA), 0, False)
        lr = SaveSpool("--------------------------------" + Chr(&HA), 0, False)
        lr = SaveSpool("SIGNATURE:" + Chr(&HA), 0, False)
        lr = SaveSpool("--------------------------------" + Chr(&HA), 0, False)

        '  Dim Black_mark As Byte() = {&H1B, &H7A, &H1B, &H79}
        '  ControlCommand(Black_mark, 4)

        If (PrintSpool(True) > 0) Then
            MessageBox.Show("Send" + lr.ToString + "Byte")
        Else
            MessageBox.Show("Failure")
        End If
    End Sub

    Private Sub BITMAP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BITMAP.Click

        'Printer initialization ESC @
        Dim Printinit(2) As Byte
        Printinit(0) = &H1B
        Printinit(1) = &H40
        ControlCommand(Printinit, 2)

        'Page mode ESC L
        Dim ESC_L(2) As Byte
        ESC_L(0) = &H1B
        ESC_L(1) = &H4C
        ControlCommand(ESC_L, 2)

        'page area setting
        '1inch printer width : 192dot = 0xC0
        '2inch printer width : 384dot = 0x180
        '3inch printer width : 576dot = 0x240
        '4inch printer width : 832dot = 0x340

        'Set page area ESC W   384x176x2 bitmap
        '1dot = 0.0125cm 
        'calculation : X axis : 0x180 => 384(decimal,2inch default width)  
        '               Y axis : 0xa7  => 167(decimal) => 167*0.0125 = 2.08cm

        'Set page area ESC W
        Dim PageSize_Set(10) As Byte
        PageSize_Set(0) = &H1B
        PageSize_Set(1) = &H57
        PageSize_Set(2) = &H0
        PageSize_Set(3) = &H0
        PageSize_Set(4) = &H0
        PageSize_Set(5) = &H0
        PageSize_Set(6) = &H80
        PageSize_Set(7) = &H1
        PageSize_Set(8) = &HA7
        PageSize_Set(9) = &H0

        ControlCommand(PageSize_Set, 10)

        'Page mode initialization CAN
        Dim CAN(1) As Byte
        CAN(0) = &H18
        ControlCommand(CAN, 1)

        'Print bitmap
        BmpSaveSpool("\woosim.bmp", 0, 0)

        'print in page mode and then change standard mode FF   
        Dim FF(1) As Byte
        FF(0) = &HC
        ControlCommand(FF, 1)

        PrintSpool(True)
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        CardRead(0)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        CardRead(1)
    End Sub
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim Card23(3) As Byte
        Card23(0) = &H1B
        Card23(1) = &H4D
        Card23(2) = &H45

        ControlCommand(Card23, 3)
        PrintSpool(True)
    End Sub
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        CardCancel()
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        'Barcode print
        BarcodeSaveSpool(UPCA, 2, 100, True, "12345678901", _2INCH, 200, 0)
        BarcodeSaveSpool(UPCE, 2, 100, True, "0123456789012", _2INCH, 200, 0)
        BarcodeSaveSpool(EAN13, 2, 100, True, "12345678901", _2INCH, 200, 0)
        BarcodeSaveSpool(EAN8, 2, 100, True, "12345678", _2INCH, 200, 0)
        BarcodeSaveSpool(CODE39, 2, 100, True, "123456789", _2INCH, 200, 0)
        BarcodeSaveSpool(ITF, 2, 100, True, "1234567892", _2INCH, 200, 0)
        BarcodeSaveSpool(CODABAR, 2, 100, True, "1234567892", _2INCH, 200, 0)
        BarcodeSaveSpool(CODE93, 2, 100, True, "1234567892", _2INCH, 200, 0)
        BarcodeSaveSpool(CODE128, 2, 100, True, "1234567892", _2INCH, 200, 0)

        PrintSpool(True)

        'barcode height GS h
        'Dim GS_h(2) As Byte
        'GS_h(0) = &H1D
        'GS_h(1) = &H68
        'GS_h(2) = &H50
        'ControlCommand(GS_h, 3)

        'barcode width GS w
        'Dim GS_w(2) As Byte
        'GS_w(0) = &H1D
        'GS_w(1) = &H77
        'GS_w(2) = &H0
        'ControlCommand(GS_w, 3)

        'print HRI character ON/OFF GS H
        'Dim HRI(2) As Byte
        'HRI(0) = &H1D
        'HRI(1) = &H48
        'HRI(2) = &H1
        'ControlCommand(HRI, 3)

        'Print barcode
        'Dim FF(0) As Byte
        'FF(0) = &HC

        ''barcode UPC-A
        'SaveSpool("UPC-A" + Chr(&HA), 0, False)
        'Dim GS_k(15) As Byte
        'GS_k(0) = &H1D
        'GS_k(1) = &H6B
        'GS_k(2) = &H41
        'GS_k(3) = &HC

        ''barcode data
        'GS_k(4) = &H31
        'GS_k(5) = &H32
        'GS_k(6) = &H33
        'GS_k(7) = &H34
        'GS_k(8) = &H35
        'GS_k(9) = &H36
        'GS_k(10) = &H37
        'GS_k(11) = &H38
        'GS_k(12) = &H39
        'GS_k(13) = &H31
        'GS_k(14) = &H32
        'GS_k(15) = &H33
        'ControlCommand(GS_k, 16)
        'ControlCommand(FF, 1)

        ''barcode UPC-E
        'SaveSpool("UPC-E" + Chr(&HA), 0, False)
        'Dim GS_k1(14) As Byte
        'GS_k1(0) = &H1D
        'GS_k1(1) = &H6B
        'GS_k1(2) = &H42
        'GS_k1(3) = &HB

        ''barcode data
        'GS_k1(4) = &H30
        'GS_k1(5) = &H32
        'GS_k1(6) = &H33
        'GS_k1(7) = &H34
        'GS_k1(8) = &H35
        'GS_k1(9) = &H36
        'GS_k1(10) = &H37
        'GS_k1(11) = &H38
        'GS_k1(12) = &H39
        'GS_k1(13) = &H31
        'GS_k1(14) = &H30

        'ControlCommand(GS_k1, 15)
        'ControlCommand(FF, 1)

        ''barcode EAN13
        'SaveSpool("EAN13" + Chr(&HA), 0, False)
        'Dim GS_k2(15) As Byte
        'GS_k2(0) = &H1D
        'GS_k2(1) = &H6B
        'GS_k2(2) = &H43
        'GS_k2(3) = &HC

        ''barcode data
        'GS_k2(4) = &H31
        'GS_k2(5) = &H32
        'GS_k2(6) = &H33
        'GS_k2(7) = &H34
        'GS_k2(8) = &H35
        'GS_k2(9) = &H36
        'GS_k2(10) = &H37
        'GS_k2(11) = &H38
        'GS_k2(12) = &H39
        'GS_k2(13) = &H31
        'GS_k2(14) = &H32
        'GS_k2(15) = &H32
        'ControlCommand(GS_k2, 16)
        'ControlCommand(FF, 1)

        ''barcode EAN8
        'SaveSpool("EAN8" + Chr(&HA), 0, False)
        'Dim GS_k3(11) As Byte
        'GS_k3(0) = &H1D
        'GS_k3(1) = &H6B
        'GS_k3(2) = &H44
        'GS_k3(3) = &H8

        ''barcode data
        'GS_k3(4) = &H31
        'GS_k3(5) = &H32
        'GS_k3(6) = &H33
        'GS_k3(7) = &H34
        'GS_k3(8) = &H35
        'GS_k3(9) = &H36
        'GS_k3(10) = &H37
        'GS_k3(11) = &H38

        'ControlCommand(GS_k3, 12)
        'ControlCommand(FF, 1)

        ''barcode code39
        'SaveSpool("code39" + Chr(&HA), 0, False)
        'Dim GS_k4(14) As Byte
        'GS_k4(0) = &H1D
        'GS_k4(1) = &H6B
        'GS_k4(2) = &H45
        'GS_k4(3) = &HB

        ''barcode data
        'GS_k4(4) = &H31
        'GS_k4(5) = &H32
        'GS_k4(6) = &H33
        'GS_k4(7) = &H34
        'GS_k4(8) = &H35
        'GS_k4(9) = &H36
        'GS_k4(10) = &H37
        'GS_k4(11) = &H38
        'GS_k4(12) = &H39
        'GS_k4(13) = &H41
        'GS_k4(14) = &H5A

        'ControlCommand(GS_k4, 15)
        'ControlCommand(FF, 1)

        ''barcode ITF
        'SaveSpool("ITF" + Chr(&HA), 0, False)
        'Dim GS_k5(9) As Byte
        'GS_k5(0) = &H1D
        'GS_k5(1) = &H6B
        'GS_k5(2) = &H46
        'GS_k5(3) = &H6
        ''barcode data
        'GS_k5(4) = &H31
        'GS_k5(5) = &H32
        'GS_k5(6) = &H33
        'GS_k5(7) = &H34
        'GS_k5(8) = &H35
        'GS_k5(9) = &H36

        'ControlCommand(GS_k5, 10)
        'ControlCommand(FF, 1)

        ''barcode codabar
        'SaveSpool("codabar" + Chr(&HA), 0, False)
        'Dim GS_k6(15) As Byte
        'GS_k6(0) = &H1D
        'GS_k6(1) = &H6B
        'GS_k6(2) = &H47
        'GS_k6(3) = &HB
        ''barcode data
        'GS_k6(4) = &H31
        'GS_k6(5) = &H32
        'GS_k6(6) = &H33
        'GS_k6(7) = &H34
        'GS_k6(8) = &H35
        'GS_k6(9) = &H36
        'GS_k6(10) = &H37
        'GS_k6(11) = &H38
        'GS_k6(12) = &H39
        'GS_k6(13) = &H41
        'GS_k6(14) = &H44

        'ControlCommand(GS_k6, 15)
        'ControlCommand(FF, 1)

        ''barcode code93
        'SaveSpool("code93" + Chr(&HA), 0, False)
        'Dim GS_k7(14) As Byte
        'GS_k7(0) = &H1D
        'GS_k7(1) = &H6B
        'GS_k7(2) = &H48
        'GS_k7(3) = &HB
        ''barcode data
        'GS_k7(4) = &H31
        'GS_k7(5) = &H32
        'GS_k7(6) = &H33
        'GS_k7(7) = &H34
        'GS_k7(8) = &H35
        'GS_k7(9) = &H36
        'GS_k7(10) = &H37
        'GS_k7(11) = &H38
        'GS_k7(12) = &H39
        'GS_k7(13) = &H21
        'GS_k7(14) = &H7D

        'ControlCommand(GS_k7, 15)
        'ControlCommand(FF, 1)

        'PrintSpool(True)
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        Dim lr As Integer

        'Printer initialization ESC @
        Dim Printinit(2) As Byte
        Printinit(0) = &H1B
        Printinit(1) = &H40
        ControlCommand(Printinit, 2)

        'Barcode print 
        Dim FF(1) As Byte
        FF(0) = &HC

        lr = SaveSpool("PDF417" + Chr(&HA), 0, False)

        'Select 2D barcode type GS Z  n (0 = PDF417 / 1 = DATAMATRIX / 2 = QR-CODE / 3 = Micro PDF417 / 4 = Trunc PDF417 / 5 = MAXI CODE)
        Dim GS_Z(3) As Byte
        GS_Z(0) = &H1D
        GS_Z(1) = &H5A
        GS_Z(2) = &H0
        ControlCommand(GS_Z, 3)

        'barcode width GS w
        Dim GS_W(3) As Byte
        GS_W(0) = &H1D
        GS_W(1) = &H77
        GS_W(2) = &H2
        ControlCommand(GS_W, 3)

        'Print 2D barcode
        Dim ESC_Z(21) As Byte
        ESC_Z(0) = &H1B
        ESC_Z(1) = &H5A

        'm = column number
        ESC_Z(2) = &H1

        'n = security level
        ESC_Z(3) = &H0

        'k = honrizontal and vertical ratio
        ESC_Z(4) = &H3

        'd = length of data (2byte)
        ESC_Z(5) = &HE
        ESC_Z(6) = &H0

        'data
        ESC_Z(7) = &H57
        ESC_Z(8) = &H57
        ESC_Z(9) = &H57
        ESC_Z(10) = &H2E
        ESC_Z(11) = &H57
        ESC_Z(12) = &H4F
        ESC_Z(13) = &H4F
        ESC_Z(14) = &H53
        ESC_Z(15) = &H49
        ESC_Z(16) = &H4D
        ESC_Z(17) = &H2E
        ESC_Z(18) = &H43
        ESC_Z(19) = &H4F
        ESC_Z(20) = &H4D

        ControlCommand(ESC_Z, 21)

        ControlCommand(FF, 1)

        Dim LF(1) As Byte
        LF(0) = &HA
        ControlCommand(LF, 1)


        lr = SaveSpool("Micro PDF417" + Chr(&HA), 0, False)

        'Select 2D barcode type GS Z  n (0 = PDF417 / 1 = DATAMATRIX / 2 = QR-CODE / 3 = Micro PDF417 / 4 = Trunc PDF417 / 5 = MAXI CODE)
        Dim GS_Z1(3) As Byte
        GS_Z1(0) = &H1D
        GS_Z1(1) = &H5A
        GS_Z1(2) = &H3
        ControlCommand(GS_Z1, 3)
        ControlCommand(GS_W, 3)
        ControlCommand(ESC_Z, 21)
        ControlCommand(FF, 1)
        ControlCommand(LF, 1)

        lr = SaveSpool("Truncated PDF417" + Chr(&HA), 0, False)

        'Select 2D barcode type GS Z  n (0 = PDF417 / 1 = DATAMATRIX / 2 = QR-CODE / 3 = Micro PDF417 / 4 = Trunc PDF417 / 5 = MAXI CODE)
        Dim GS_Z2(3) As Byte
        GS_Z2(0) = &H1D
        GS_Z2(1) = &H5A
        GS_Z2(2) = &H4
        ControlCommand(GS_Z2, 3)
        ControlCommand(GS_W, 3)
        ControlCommand(ESC_Z, 21)
        ControlCommand(FF, 1)
        ControlCommand(LF, 1)

        lr = SaveSpool("DATAMAREIX" + Chr(&HA), 0, False)

        'Select 2D barcode type GS Z  n (0 = PDF417 / 1 = DATAMATRIX / 2 = QR-CODE / 3 = Micro PDF417 / 4 = Trunc PDF417 / 5 = MAXI CODE)
        Dim GS_Z3(3) As Byte
        GS_Z3(0) = &H1D
        GS_Z3(1) = &H5A
        GS_Z3(2) = &H1
        ControlCommand(GS_Z3, 3)

        'Print 2D barcode
        Dim ESC_Z1(21) As Byte
        ESC_Z1(0) = &H1B
        ESC_Z1(1) = &H5A

        'm = height of the symbol (0:autosize)
        ESC_Z1(2) = &H0

        'n = width of the symbol (0:autosize)
        ESC_Z1(3) = &H0

        'k = module size
        ESC_Z1(4) = &H3

        'd = length of data (2byte)
        ESC_Z1(5) = &HE
        ESC_Z1(6) = &H0

        'data
        ESC_Z1(7) = &H57
        ESC_Z1(8) = &H57
        ESC_Z1(9) = &H57
        ESC_Z1(10) = &H2E
        ESC_Z1(11) = &H57
        ESC_Z1(12) = &H4F
        ESC_Z1(13) = &H4F
        ESC_Z1(14) = &H53
        ESC_Z1(15) = &H49
        ESC_Z1(16) = &H4D
        ESC_Z1(17) = &H2E
        ESC_Z1(18) = &H43
        ESC_Z1(19) = &H4F
        ESC_Z1(20) = &H4D
        ControlCommand(ESC_Z1, 21)
        ControlCommand(FF, 1)

        ControlCommand(LF, 1)

        lr = SaveSpool("QR-CODE" + Chr(&HA), 0, False)

        'Select 2D barcode type GS Z  n (0 = PDF417 / 1 = DATAMATRIX / 2 = QR-CODE / 3 = Micro PDF417 / 4 = Trunc PDF417 / 5 = MAXI CODE)
        Dim GS_Z4(3) As Byte
        GS_Z4(0) = &H1D
        GS_Z4(1) = &H5A
        GS_Z4(2) = &H2
        ControlCommand(GS_Z4, 3)

        'Print 2D barcode
        Dim ESC_Z2(21) As Byte
        ESC_Z2(0) = &H1B
        ESC_Z2(1) = &H5A

        'm = version of the symbol
        ESC_Z2(2) = &H0

        'n = EC level (L:0x4c M:0x4d Q:0x51 H:0x48)
        ESC_Z2(3) = &H4D

        'k = module size
        ESC_Z2(4) = &H3

        'd = length of data (2byte)
        ESC_Z2(5) = &HE
        ESC_Z2(6) = &H0

        'data
        ESC_Z2(7) = &H57
        ESC_Z2(8) = &H57
        ESC_Z2(9) = &H57
        ESC_Z2(10) = &H2E
        ESC_Z2(11) = &H57
        ESC_Z2(12) = &H4F
        ESC_Z2(13) = &H4F
        ESC_Z2(14) = &H53
        ESC_Z2(15) = &H49
        ESC_Z2(16) = &H4D
        ESC_Z2(17) = &H2E
        ESC_Z2(18) = &H43
        ESC_Z2(19) = &H4F
        ESC_Z2(20) = &H4D
        ControlCommand(ESC_Z2, 21)

        ControlCommand(FF, 1)
        ControlCommand(LF, 1)

        lr = SaveSpool("MAXICODE" + Chr(&HA), 0, False)

        'Select 2D barcode type GS Z  n (0 = PDF417 / 1 = DATAMATRIX / 2 = QR-CODE / 3 = Micro PDF417 / 4 = Trunc PDF417 / 5 = MAXI CODE)
        Dim GS_Z5(3) As Byte
        GS_Z5(0) = &H1D
        GS_Z5(1) = &H5A
        GS_Z5(2) = &H5
        ControlCommand(GS_Z5, 3)

        'Print 2D barcode
        Dim ESC_Z3(21) As Byte
        ESC_Z3(0) = &H1B
        ESC_Z3(1) = &H5A

        'm = mode of MAXICODE
        ESC_Z3(2) = &H4

        'n = dummy
        ESC_Z3(3) = &H4D

        'k = dummy
        ESC_Z3(4) = &H3

        'd = length of data (2byte)
        ESC_Z3(5) = &HE
        ESC_Z3(6) = &H0

        'data
        ESC_Z3(7) = &H57
        ESC_Z3(8) = &H57
        ESC_Z3(9) = &H57
        ESC_Z3(10) = &H2E
        ESC_Z3(11) = &H57
        ESC_Z3(12) = &H4F
        ESC_Z3(13) = &H4F
        ESC_Z3(14) = &H53
        ESC_Z3(15) = &H49
        ESC_Z3(16) = &H4D
        ESC_Z3(17) = &H2E
        ESC_Z3(18) = &H43
        ESC_Z3(19) = &H4F
        ESC_Z3(20) = &H4D
        ControlCommand(ESC_Z3, 21)

        ControlCommand(FF, 1)
        ControlCommand(LF, 1)
        PrintSpool(True)
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Me.Close()
    End Sub



    Protected Overrides Sub WndProc(ByRef msg As Message)
        If msg.Msg = WM_RECEIVE_MSG Then
            If msg.WParam = CType(DATA, IntPtr) Then
             
                Me.TextBox1.Text = "DATA"

                Dim sScanData As String
                Dim Revstr As String = Nothing
                If (True) Then
                    sScanData = Marshal.PtrToStringUni(msg.LParam)
                    Dim CardData() As Byte = System.Text.Encoding.Unicode.GetBytes(sScanData)

                    Dim i As Integer
                    For i = 0 To CardData.Length - 1
                        Revstr += Chr(CardData(i))
                    Next

                End If
                Me.TextBox2.Text = Revstr
                
            Else
                If msg.WParam = CType(EOT, IntPtr) Then
                    Me.TextBox1.Text = "EOT"

                Else
                    If msg.WParam = CType(ETX, IntPtr) Then
                        Me.TextBox1.Text = "ETX"

                    Else
                        If msg.WParam = CType(ACK, IntPtr) Then
                            Me.TextBox1.Text = "ACK"

                        Else
                            If msg.WParam = CType(NACK, IntPtr) Then
                                Me.TextBox1.Text = "NACK"


                            Else
                                If msg.WParam = CType(MSR_FAIL, IntPtr) Then
                                    Me.TextBox1.Text = "MSR_FAIL"
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
        MyBase.WndProc(msg)
    End Sub

  
    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        Dim lr As Integer

        'Printer initialization ESC @
        Dim Printinit(2) As Byte
        Printinit(0) = &H1B
        Printinit(1) = &H40
        ControlCommand(Printinit, 2)

        'GS1 Databar barcode
        Dim GS_h(3) As Byte
        GS_h(0) = &H1D
        GS_h(1) = &H68
        GS_h(2) = &H50
        ControlCommand(GS_h, 3)

        lr = SaveSpool(" " + Chr(&HA), 0, False)


        'GS1 Databar Type : 0
        lr = SaveSpool("GS1 Databar Type : 0" + Chr(&HA), 0, False)
        lr = SaveSpool("Input data : 0001234567890" + Chr(&HA), 0, False)

        Dim GS_k(18) As Byte
        GS_k(0) = &H1D
        GS_k(1) = &H31
        GS_k(2) = &H0
        GS_k(3) = &H2

        'data
        GS_k(4) = &H30
        GS_k(5) = &H30
        GS_k(6) = &H30
        GS_k(7) = &H31
        GS_k(8) = &H32
        GS_k(9) = &H33
        GS_k(10) = &H34
        GS_k(11) = &H35
        GS_k(12) = &H36
        GS_k(13) = &H37
        GS_k(14) = &H38
        GS_k(15) = &H39
        GS_k(16) = &H30
        GS_k(17) = &H0

        ControlCommand(GS_k, 18)

        'barcode print
        Dim page_ff(1) As Byte
        page_ff(0) = &HC
        ControlCommand(page_ff, 1)

        lr = SaveSpool(" " + Chr(&HA) + Chr(&HA), 0, False)

        'GS1 Databar Type : 1
        lr = SaveSpool("GS1 Databar Type : 1" + Chr(&HA), 0, False)
        lr = SaveSpool("Input data : 0001234567890" + Chr(&HA), 0, False)

        Dim GS_k1(18) As Byte
        GS_k1(0) = &H1D
        GS_k1(1) = &H31
        GS_k1(2) = &H1
        GS_k1(3) = &H2

        'data
        GS_k1(4) = &H30
        GS_k1(5) = &H30
        GS_k1(6) = &H30
        GS_k1(7) = &H31
        GS_k1(8) = &H32
        GS_k1(9) = &H33
        GS_k1(10) = &H34
        GS_k1(11) = &H35
        GS_k1(12) = &H36
        GS_k1(13) = &H37
        GS_k1(14) = &H38
        GS_k1(15) = &H39
        GS_k1(16) = &H30
        GS_k1(17) = &H0

        ControlCommand(GS_k1, 18)

        'barcode print
        ControlCommand(page_ff, 1)

        lr = SaveSpool(" " + Chr(&HA) + Chr(&HA), 0, False)

        'GS1 Databar Type : 2
        lr = SaveSpool("GS1 Databar Type : 2" + Chr(&HA), 0, False)
        lr = SaveSpool("Input data : 0001234567890" + Chr(&HA), 0, False)

        Dim GS_k2(18) As Byte
        GS_k2(0) = &H1D
        GS_k2(1) = &H31
        GS_k2(2) = &H2
        GS_k2(3) = &H2

        'data
        GS_k2(4) = &H30
        GS_k2(5) = &H30
        GS_k2(6) = &H30
        GS_k2(7) = &H31
        GS_k2(8) = &H32
        GS_k2(9) = &H33
        GS_k2(10) = &H34
        GS_k2(11) = &H35
        GS_k2(12) = &H36
        GS_k2(13) = &H37
        GS_k2(14) = &H38
        GS_k2(15) = &H39
        GS_k2(16) = &H30
        GS_k2(17) = &H0

        ControlCommand(GS_k2, 18)

        'barcode print
        ControlCommand(page_ff, 1)

        lr = SaveSpool(" " + Chr(&HA) + Chr(&HA), 0, False)

        'GS1 Databar Type : 3
        lr = SaveSpool("GS1 Databar Type : 3" + Chr(&HA), 0, False)
        lr = SaveSpool("Input data : 0001234567890" + Chr(&HA), 0, False)

        Dim GS_k3(18) As Byte
        GS_k3(0) = &H1D
        GS_k3(1) = &H31
        GS_k3(2) = &H3
        GS_k3(3) = &H2

        'data
        GS_k3(4) = &H30
        GS_k3(5) = &H30
        GS_k3(6) = &H30
        GS_k3(7) = &H31
        GS_k3(8) = &H32
        GS_k3(9) = &H33
        GS_k3(10) = &H34
        GS_k3(11) = &H35
        GS_k3(12) = &H36
        GS_k3(13) = &H37
        GS_k3(14) = &H38
        GS_k3(15) = &H39
        GS_k3(16) = &H30
        GS_k3(17) = &H0

        ControlCommand(GS_k3, 18)

        'barcode print
        ControlCommand(page_ff, 1)

        lr = SaveSpool(" " + Chr(&HA) + Chr(&HA), 0, False)

        'GS1 Databar Type : 4
        lr = SaveSpool("GS1 Databar Type : 4" + Chr(&HA), 0, False)
        lr = SaveSpool("Input data : 0001234567890" + Chr(&HA), 0, False)

        Dim GS_k4(18) As Byte
        GS_k4(0) = &H1D
        GS_k4(1) = &H31
        GS_k4(2) = &H4
        GS_k4(3) = &H2

        'data
        GS_k4(4) = &H30
        GS_k4(5) = &H30
        GS_k4(6) = &H30
        GS_k4(7) = &H31
        GS_k4(8) = &H32
        GS_k4(9) = &H33
        GS_k4(10) = &H34
        GS_k4(11) = &H35
        GS_k4(12) = &H36
        GS_k4(13) = &H37
        GS_k4(14) = &H38
        GS_k4(15) = &H39
        GS_k4(16) = &H30
        GS_k4(17) = &H0

        ControlCommand(GS_k4, 18)

        'barcode print
        ControlCommand(page_ff, 1)

        lr = SaveSpool(" " + Chr(&HA) + Chr(&HA), 0, False)

        'GS1 Databar Type : 5
        lr = SaveSpool("GS1 Databar Type : 5" + Chr(&HA), 0, False)
        lr = SaveSpool("Input data : [01]90012345678908[3103]012233" + Chr(&HA), 0, False)

        Dim GS_k5(35) As Byte
        GS_k5(0) = &H1D
        GS_k5(1) = &H31
        GS_k5(2) = &H5
        GS_k5(3) = &H2

        'data
        GS_k5(4) = &H5B
        GS_k5(5) = &H30
        GS_k5(6) = &H31
        GS_k5(7) = &H5D
        GS_k5(8) = &H39
        GS_k5(9) = &H30
        GS_k5(10) = &H30
        GS_k5(11) = &H31
        GS_k5(12) = &H32
        GS_k5(13) = &H33
        GS_k5(14) = &H34
        GS_k5(15) = &H35
        GS_k5(16) = &H36
        GS_k5(17) = &H37
        GS_k5(18) = &H38
        GS_k5(19) = &H39
        GS_k5(20) = &H30
        GS_k5(21) = &H38
        GS_k5(22) = &H5B
        GS_k5(23) = &H33
        GS_k5(24) = &H31
        GS_k5(25) = &H30
        GS_k5(26) = &H33
        GS_k5(27) = &H5D
        GS_k5(28) = &H30
        GS_k5(29) = &H31
        GS_k5(30) = &H32
        GS_k5(31) = &H32
        GS_k5(32) = &H33
        GS_k5(33) = &H33
        GS_k5(34) = &H30

        ControlCommand(GS_k5, 35)

        'barcode print
        ControlCommand(page_ff, 1)

        lr = SaveSpool(" " + Chr(&HA) + Chr(&HA), 0, False)

        'GS1 Databar Type : 6
        lr = SaveSpool("GS1 Databar Type : 6" + Chr(&HA), 0, False)
        lr = SaveSpool("Input data : [01]90012345678908[3103]012233[15]991231" + Chr(&HA), 0, False)

        Dim GS_k6(45) As Byte
        GS_k6(0) = &H1D
        GS_k6(1) = &H31
        GS_k6(2) = &H6
        GS_k6(3) = &H2

        'data
        GS_k6(4) = &H5B
        GS_k6(5) = &H30
        GS_k6(6) = &H31
        GS_k6(7) = &H5D
        GS_k6(8) = &H39
        GS_k6(9) = &H30
        GS_k6(10) = &H30
        GS_k6(11) = &H31
        GS_k6(12) = &H32
        GS_k6(13) = &H33
        GS_k6(14) = &H34
        GS_k6(15) = &H35
        GS_k6(16) = &H36
        GS_k6(17) = &H37
        GS_k6(18) = &H38
        GS_k6(19) = &H39
        GS_k6(20) = &H30
        GS_k6(21) = &H38
        GS_k6(22) = &H5B
        GS_k6(23) = &H33
        GS_k6(24) = &H31
        GS_k6(25) = &H30
        GS_k6(26) = &H33
        GS_k6(27) = &H5D
        GS_k6(28) = &H30
        GS_k6(29) = &H31
        GS_k6(30) = &H32
        GS_k6(31) = &H32
        GS_k6(32) = &H33
        GS_k6(33) = &H33
        GS_k6(34) = &H5B
        GS_k6(35) = &H31
        GS_k6(36) = &H35
        GS_k6(37) = &H5D
        GS_k6(38) = &H39
        GS_k6(39) = &H39
        GS_k6(40) = &H31
        GS_k6(41) = &H32
        GS_k6(42) = &H33
        GS_k6(43) = &H31
        GS_k6(44) = &H30

        ControlCommand(GS_k6, 45)

        'barcode print
        ControlCommand(page_ff, 1)

        lr = SaveSpool(" " + Chr(&HA) + Chr(&HA), 0, False)

        PrintSpool(True)
    End Sub
End Class




